package spoon.examples.distcalc.processing;

import java.util.ArrayList;

import spoon.examples.distcalc.annotation.Service;
import spoon.examples.distcalc.template.ServicesImplTemplate;
import spoon.examples.distcalc.template._MemoryCellType_;
import spoon.processing.AbstractAnnotationProcessor;
import spoon.reflect.Factory;
import spoon.reflect.declaration.CtClass;
import spoon.reflect.declaration.CtInterface;
import spoon.reflect.declaration.CtMethod;
import spoon.reflect.declaration.CtPackage;
import spoon.reflect.declaration.CtParameter;
import spoon.reflect.declaration.CtSimpleType;
import spoon.reflect.declaration.ModifierKind;
import spoon.reflect.reference.CtTypeReference;
import spoon.template.Substitution;

public class ServiceProcessor extends
		AbstractAnnotationProcessor<Service, CtMethod<?>> {

	public static String getMemoryCellTypeName(String funName) {
		return "Node_" + funName + "_mem";
	}

	public static CtClass<?> getFunsImpl(Factory f, CtInterface<?> services) {
		CtTypeReference<?> i = f.Interface().createReference(services);
		for (CtSimpleType<?> t : f.Type().getAll()) {
			if ((t instanceof CtClass)
					&& !t.getModifiers().contains(ModifierKind.ABSTRACT)
					&& ((CtClass<?>) t).getSuperInterfaces().contains(i)) {
				return (CtClass<?>) t;
			}
		}
		CtClass<?> c = f.Class().create(services.getQualifiedName() + "Impl");
		c.getSuperInterfaces().add(i);
		c.getModifiers().add(ModifierKind.PUBLIC);
		return c;
	}

	public void process(Service service, CtMethod<?> method) {
		Factory f = method.getFactory();
		CtPackage p = method.getParent(CtPackage.class);
		CtInterface<?> i = method.getParent(CtInterface.class);
		CtClass<?> c = getFunsImpl(f, i);
		ServicesImplTemplate t = new ServicesImplTemplate(f.Type()
				.createReference(
						p.getQualifiedName() + "." + "Node_"
								+ method.getSimpleName()), null,
				f.Type()
						.createReference(
								p.getQualifiedName()
										+ "."
										+ getMemoryCellTypeName(method
												.getSimpleName())), method
						.getType().getActualClass(), method.getSimpleName(),
				new ArrayList<CtParameter<?>>(method.getParameters()));
		Substitution.insertAll(c, t);
		_MemoryCellType_ memType = new _MemoryCellType_(f, f.Type()
				.createReference(
						p.getQualifiedName() + "." + "Node_"
								+ method.getSimpleName()), method.getType()
				.getActualClass(), method.getSimpleName(),
				new ArrayList<CtParameter<?>>(method.getParameters()));
		CtClass<?> memClass = Substitution.substitute(memType, f.Template().get(
				_MemoryCellType_.class));
		p.getTypes().add(memClass);
		memClass.setParent(p);
	}

}
